<?php
namespace AkTest\Test;

use Ak\Test\AbstractTestCase;
use PHPUnit\Framework\MockObject\MockObject;
use PHPUnit\Framework\TestCase as BaseTestCase;

/**
 * Class AbstractTestCase
 *
 * @package AkTest\Test
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/test
 */
abstract class TestCase extends BaseTestCase
{
    /**
     * @param array $providers
     * @return AbstractTestCase|MockObject
     */
    protected function getTestUnderTest(array $providers = []): AbstractTestCase
    {
        try {
            /** @var AbstractTestCase|MockObject $test */
            $test = $this->getMockForAbstractClass(AbstractTestCase::class);
            $refl = new \ReflectionClass($test);
        } catch (\ReflectionException $e) {
            return null;
        }

        $prop = $refl->getProperty('providers');
        $prop->setAccessible(true);
        $prop->setValue($test, $providers);

        return $test;
    }
}